/*
 * arch/ppc/platforms/mcc200.h
 * 
 * Definitions for MCC200 board support
 * 
 * Copyright 2006 DENX Software Engineering <wd@denx.de>
 * Copyright 2003 Motorola Inc.
 * Copyright 2003 MontaVista Software Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */
 /*
 * From Processor to PCI:
 *   PCI Mem Space: 0x90000000 - 0xa0000000 -> 0x90000000 - 0xa0000000 (256 MB)
 *   PCI I/O Space: 0xa0000000 - 0xa1000000 -> 0xa0000000 - 0xa1000000 (16 MB)
 *
 * From PCI to Processor:
 *   System Memory: 0x00000000 -> 0x00000000
 */


#ifndef __PLATFORMS_MCC200_H
#define __PLATFORMS_MCC200_H

#define MPC5xxx_PROC_PCI_MEM_START	0x90000000U
#define MPC5xxx_PROC_PCI_MEM_END	0x9fffffffU
#define MPC5xxx_PCI_MEM_START		0x90000000U
#define MPC5xxx_PCI_MEM_END		0x9fffffffU
#define MPC5xxx_PCI_MEM_SIZE		(MPC5xxx_PCI_MEM_END + 1 - MPC5xxx_PCI_MEM_START)

#define MPC5xxx_PCI_MEM_VIRT_START	0x90000000U

#define MPC5xxx_PROC_PCI_IO_START	0xa0000000U
#define MPC5xxx_PROC_PCI_IO_END		0xa0ffffffU
#define MPC5xxx_PCI_IO_START		0xa0000000U
#define MPC5xxx_PCI_IO_END		0xa0ffffffU
#define MPC5xxx_PCI_IO_SIZE		(MPC5xxx_PCI_IO_END + 1 - MPC5xxx_PCI_IO_START)

#define MPC5xxx_PCI_IO_VIRT_START	0xa0000000U

#define MPC5xxx_PCI_DRAM_OFFSET		0x00000000U
#define MPC5xxx_PCI_PHY_MEM_OFFSET	0x00000000U

#define MPC5xxx_ISA_IO_BASE		MPC5xxx_PROC_PCI_IO_START
#define MPC5xxx_ISA_MEM_BASE		MPC5xxx_PROC_PCI_MEM_START

#ifdef CONFIG_UBOOT
#define	MPC5xxx_INIT_BAUD_BASE		0
#else
#define	MPC5xxx_INIT_BAUD_BASE		CONFIG_PPC_5xxx_IPBFREQ
#endif

#define STD_PSC_OP(num)					\
{							\
	.magic = 0,					\
	.baud_base = MPC5xxx_INIT_BAUD_BASE,		\
	.irq = MPC5xxx_PSC##num##_IRQ,			\
	.flags = ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST, 	\
	.iomem_base = (void *)MPC5xxx_PSC##num,		\
	.io_type = SERIAL_IO_MEM,			\
},

#ifdef CONFIG_FB_MCC200_VFB
#define SERIAL_PORT_DFNS	\
	STD_PSC_OP(1)
#else
#define SERIAL_PORT_DFNS	\
	STD_PSC_OP(1)		\
	STD_PSC_OP(2)
#endif


#define SERIAL_BAUD_BASE	(7372800 / 16)
#if 0 /* Options */
#define SERIAL_BAUD_BASE	(1843200 / 16)
#define SERIAL_BAUD_BASE	(3686400 / 16)
#define SERIAL_BAUD_BASE	(7372800 / 16)
#endif
/* UART expander on the core */
#define SERIAL_PORT_BASE	0x80000000
#if !defined(CONFIG_PRS200)
/* UART expander on the daughterboard */
#define SERIAL2_PORT_BASE	0x80010000
#endif
#define STD_SERIAL_OP(num, irqnum) \
{							\
	.magic = 0,					\
	.baud_base = SERIAL_BAUD_BASE,		\
	.irq = irqnum,			\
	.flags = ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST, 	\
	.iomem_base = NULL,				\
	.io_type = SERIAL_IO_MEM,			\
},

#if defined(CONFIG_PRS200)
#define EXTERN_SERIAL_PORT_DFNS \
  STD_SERIAL_OP(0, MPC5xxx_IRQ2) \
  STD_SERIAL_OP(1, MPC5xxx_IRQ2) \
  STD_SERIAL_OP(2, MPC5xxx_IRQ2) \
  STD_SERIAL_OP(3, MPC5xxx_IRQ2)
#else
#define EXTERN_SERIAL_PORT_DFNS \
  STD_SERIAL_OP(0, MPC5xxx_IRQ2) \
  STD_SERIAL_OP(1, MPC5xxx_IRQ2) \
  STD_SERIAL_OP(2, MPC5xxx_IRQ2) \
  STD_SERIAL_OP(3, MPC5xxx_IRQ2) \
  STD_SERIAL_OP(4, MPC5xxx_IRQ3) \
  STD_SERIAL_OP(5, MPC5xxx_IRQ3) \
  STD_SERIAL_OP(6, MPC5xxx_IRQ3) \
  STD_SERIAL_OP(7, MPC5xxx_IRQ3)
#endif /* CONFIG_PRS200 */
#endif /* __PLATFORMS_MCC200_H */
