/*
 * arch/ppc/platform/mpc834x.c
 *
 * MPC834x I/O descriptions
 *
 * Copyright 2005 DENX Software Engineering
 * Code borrowed from mpc85xx.c files.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#include <linux/init.h>
#include <asm/mpc83xx.h>
#include <asm/ocp.h>

/* These should be defined in platform code */
extern struct ocp_gfar_data mpc834x_tsec1_def;
extern struct ocp_gfar_data mpc834x_tsec2_def;
extern struct ocp_mpc_i2c_data mpc834x_i2c1_def;

/* We use offsets for paddr since we do not know at compile time
 * what IMMRBAR is, platform code should fix this up in
 * setup_arch
 *
 * Only the first IRQ is given even if a device has
 * multiple lines associated with ita
 */
struct ocp_def core_ocp[] = {
	{ .vendor       = OCP_VENDOR_MOTOROLA,
	  .function     = OCP_FUNC_IIC,
	  .index        = 0,
	  .paddr        = MPC83xx_IIC1_OFFSET,
	  .irq          = MPC83xx_IRQ_IIC1,
	  .pm           = OCP_CPM_NA,
	  .additions    = &mpc834x_i2c1_def,
	},
	{ .vendor       = OCP_VENDOR_MOTOROLA,
	  .function     = OCP_FUNC_16550,
	  .index        = 0,
	  .paddr        = MPC83xx_UART0_OFFSET,
	  .irq          = MPC83xx_IRQ_UART1,
	  .pm           = OCP_CPM_NA,
	},
	{ .vendor       = OCP_VENDOR_MOTOROLA,
	  .function     = OCP_FUNC_16550,
	  .index        = 1,
	  .paddr        = MPC83xx_UART1_OFFSET,
	  .irq          = MPC83xx_IRQ_UART2,
	  .pm           = OCP_CPM_NA,
	},
	{ .vendor       = OCP_VENDOR_MOTOROLA,
	  .function     = OCP_FUNC_GFAR,
	  .index        = 0,
	  .paddr        = MPC83xx_ENET1_OFFSET,
	  .irq          = MPC83xx_IRQ_TSEC1_TX,
	  .pm           = OCP_CPM_NA,
	  .additions    = &mpc834x_tsec1_def,
	},
	{ .vendor       = OCP_VENDOR_MOTOROLA,
	  .function     = OCP_FUNC_GFAR,
	  .index        = 1,
	  .paddr        = MPC83xx_ENET2_OFFSET,
	  .irq          = MPC83xx_IRQ_TSEC2_TX,
	  .pm           = OCP_CPM_NA,
	  .additions    = &mpc834x_tsec2_def,
	},
	{ .vendor       = OCP_VENDOR_MOTOROLA,
	  .function     = OCP_FUNC_DMA,
	  .index        = 0,
	  .paddr        = MPC83xx_DMA_OFFSET,
	  .irq          = MPC83xx_IRQ_DMA,
	  .pm           = OCP_CPM_NA,
	},
	{ .vendor       = OCP_VENDOR_INVALID
	}
};
