/*
 * arch/ppc/platforms/o2dnt.h
 * 
 * Copyright 2005 DENX Software Engineering (wd@denx.de)
 *
 * Platform board support for O2DNT, based on arch/ppc/platform/icecube.h
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */
 /*
 * From Processor to PCI:
 *   PCI Mem Space: 0x90000000 - 0xa0000000 -> 0x90000000 - 0xa0000000 (256 MB)
 *   PCI I/O Space: 0xa0000000 - 0xa1000000 -> 0xa0000000 - 0xa1000000 (16 MB)
 *
 * From PCI to Processor:
 *   System Memory: 0x00000000 -> 0x00000000
 */

#ifndef __PLATFORMS_O2DNT_H
#define __PLATFORMS_O2DNT_H

#define MPC5xxx_PROC_PCI_MEM_START	0x90000000U
#define MPC5xxx_PROC_PCI_MEM_END	0x9fffffffU
#define MPC5xxx_PCI_MEM_START		0x90000000U
#define MPC5xxx_PCI_MEM_END		0x9fffffffU
#define MPC5xxx_PCI_MEM_SIZE		(MPC5xxx_PCI_MEM_END + 1 - MPC5xxx_PCI_MEM_START)

#define MPC5xxx_PCI_MEM_VIRT_START	0x90000000U

#define MPC5xxx_PROC_PCI_IO_START	0xa0000000U
#define MPC5xxx_PROC_PCI_IO_END		0xa0ffffffU
#define MPC5xxx_PCI_IO_START		0xa0000000U
#define MPC5xxx_PCI_IO_END		0xa0ffffffU
#define MPC5xxx_PCI_IO_SIZE		(MPC5xxx_PCI_IO_END + 1 - MPC5xxx_PCI_IO_START)

#define MPC5xxx_PCI_IO_VIRT_START	0xa0000000U

#define MPC5xxx_PCI_DRAM_OFFSET		0x00000000U
#define MPC5xxx_PCI_PHY_MEM_OFFSET	0x00000000U

#define MPC5xxx_ISA_IO_BASE		MPC5xxx_PROC_PCI_IO_START
#define MPC5xxx_ISA_MEM_BASE		MPC5xxx_PROC_PCI_MEM_START

#define RS_TABLE_SIZE  2

#ifdef CONFIG_UBOOT
#define	MPC5xxx_INIT_BAUD_BASE		0
#else
#define	MPC5xxx_INIT_BAUD_BASE		CONFIG_PPC_5xxx_IPBFREQ
#endif

#define STD_PSC_OP(num)					\
{							\
	.magic = 0,					\
	.baud_base = MPC5xxx_INIT_BAUD_BASE,		\
	.irq = MPC5xxx_PSC##num##_IRQ,			\
	.flags = ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST, 	\
	.iomem_base = (void *)MPC5xxx_PSC##num,		\
	.io_type = SERIAL_IO_MEM,			\
},

#define SERIAL_PORT_DFNS	\
	STD_PSC_OP(5)		\
	STD_PSC_OP(4)

#endif /* __PLATFORMS_O2DNT_H */
