/*
 * arch/ppc/kernel/sorcery_pci.h
 */

#include <linux/config.h>
#include <asm/mpc8220.h>

#ifndef __SORCERY_PCI_H
#define __SORCERY_PCI_H

#define SORCERY_HOST_BRIDGE_IDSEL	16

#define SORCERY_PCI_REG_MMAP		MPC8220_PCI

#define SORCERY_PCI_OFF_DRAM		0x00000000
#define SORCERY_PCI_OFF_MEM_PHY	0x00000000

/******************************************************/
#define SORCERY_PCI_SPACE_CFG		0x70000000
#define SORCERY_PCI_SPACE_IO		0x71000000
#define SORCERY_PCI_SPACE_IO_END	0x71ffffff
#define SORCERY_PCI_SPACE_MEM		0x80000000
#define SORCERY_PCI_SPACE_MEM_END	0xbfffffff  /* 1GB */

/******************************************************/
#define SORCERY_PCI_CFG_DATA		(SORCERY_PCI_SPACE_CFG)
#define SORCERY_PCI_CFG_ADDRESS	(SORCERY_PCI_REG_MMAP + 0xF8)

#define SORCERY_PCI_IO_START		(SORCERY_PCI_SPACE_IO)
#define SORCERY_PCI_IO_END		(SORCERY_PCI_SPACE_IO_END)

#define SORCERY_PCI_IO_PHY_START	(SORCERY_PCI_SPACE_IO)
#define SORCERY_PCI_IO_PHY_END		(SORCERY_PCI_SPACE_IO_END)

#define SORCERY_PCI_MEM_START		(SORCERY_PCI_SPACE_MEM)
#define SORCERY_PCI_MEM_END		(SORCERY_PCI_SPACE_MEM_END)

#define SORCERY_PCI_MEM_PHY_START	(SORCERY_PCI_SPACE_MEM)
#define SORCERY_PCI_MEM_PHY_END 	(SORCERY_PCI_SPACE_MEM_END)

#define SORCERY_PCI_IO_LOWER		(SORCERY_PCI_IO_START)
#define SORCERY_PCI_IO_UPPER		(SORCERY_PCI_IO_END)

#define SORCERY_PCI_MEM_LOWER		(SORCERY_PCI_MEM_START)
#define SORCERY_PCI_MEM_UPPER		(SORCERY_PCI_MEM_END)

/* Fuctions declarations */
void sorcery_find_bridges(void);

#endif /* __SORCERY_PCI_H */
