/*
 * arch/ppc/platforms/tqm834x.h
 *
 * TQM834x board definitions
 *
 * Copyright 2005 DENX Software Engineering
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 */

#ifndef __MACH_TQM834x_H
#define __MACH_TQM834x_H

#include <linux/config.h>

#define VIRT_IMMRBAR		((uint)0xff400000)
#define IMMRBAR_SIZE		((uint)1024*1024)

/*
 * Serial Config
 */
#ifdef CONFIG_SERIAL_MANY_PORTS
#define RS_TABLE_SIZE	64
#else
#define RS_TABLE_SIZE	2
#endif

#ifdef CONFIG_SERIAL_DETECT_IRQ
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST|ASYNC_AUTO_IRQ)
#else
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST)
#endif

#define UART0_INT		MPC83xx_IRQ_UART1
#define UART1_INT		MPC83xx_IRQ_UART2
#define UART0_IO_BASE		((uint)(VIRT_IMMRBAR + MPC83xx_UART0_OFFSET))
#define UART1_IO_BASE		((uint)(VIRT_IMMRBAR + MPC83xx_UART1_OFFSET))
#define BASE_BAUD		0

#define STD_UART_OP(num)					\
	{							\
		0,						\
		baud_base: BASE_BAUD,				\
		port: 0,					\
		irq: UART##num##_INT,				\
		flags: STD_COM_FLAGS,				\
		iomem_reg_shift: 0,				\
		iomem_base: (void*)UART##num##_IO_BASE,		\
		io_type: SERIAL_IO_MEM,				\
	},

#define SERIAL_PORT_DFNS	\
	STD_UART_OP(0)		\
	STD_UART_OP(1)

#endif	/* __MACH_TQM834x_H */



