/*
 * drivers/spi/spi-algo-mpc5xxx-psc.h
 *
 * SPI support via CODEC mode of PSC for MPC5xxx processors
 *
 * 2003 (c) Wolfgang Denk, DENX Software Engineering, <wd@denx.de>.  This
 * file is licensed under the terms of the GNU General Public License
 * version 2.  This program is licensed "as is" without any warranty of
 * any kind, whether express or implied.
 */
 
#ifndef _SPI_ALGO_MPC5XXX_PSC_H_
#define _SPI_ALGO_MPC5XXX_PSC_H_

#include <asm/mpc5xxx.h>

struct spi_algo_mpc5xxx_psc_data {
	struct mpc5xxx_psc * const regs;	/* psc module registers  */
	const int flags;
#define MPC5XXX_PSC_SPI_USE_FIFO	0x01

	/* Current state variables */
	struct semaphore sema; /* mutex to enforce one transfer at a time */
	wait_queue_head_t wait_queue; /* Wait on this queue during transfer */

	/* Warning: The following fields are not protected by a mutex.
	 * They can only be changed before a transfer starts or after
	 * a transfer ends.  During a transfer the isr will fiddle with
	 * them */
	int rx_count;		/* remaining bytes to be received */
	uint8_t *rx_ptr;	/* pointer for next RX character */
};

int spi_mpc5xxx_psc_add_bus(struct spi_adapter *);
int spi_mpc5xxx_psc_del_bus(struct spi_adapter *);

#endif /* _SPI_ALGO_MPC5XXX_PSC_H_ */
