/*
 * drivers/spi/spi-eval.c
 *
 * SPI adapter driver for mpc5200 board with MPC5xxx
 *
 * 2005 (c) Wolfgang Denk, DENX Software Engineering, <wd@denx.de>.
 *
 * This file is licensed under the terms of the GNU General Public License
 * version 2.  This program is licensed "as is" without any warranty of
 * any kind, whether express or implied.
 */

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <asm/mpc5xxx.h>
#include <linux/spi.h>
#include "spi-algo-mpc5xxx.h"

static struct spi_algo_mpc5xxx_data spi_eval_data = {
	(struct mpc5xxx_psc *)MPC5xxx_PSC1,
};

static struct spi_adapter spi_eval_ops = {
	name:		"SPI-Evaluator",
	algo_data:	&spi_eval_data,
};

static int __init spi_eval_init(void)
{
	if (spi_mpc5xxx_add_bus(&spi_eval_ops))
		return -ENODEV;
	return 0;
}

static void __exit spi_eval_exit(void)
{
	spi_mpc5xxx_del_bus(&spi_eval_ops);
}

module_init(spi_eval_init);
module_exit(spi_eval_exit);

MODULE_LICENSE("GPL");
