#ifndef _hmi5200_panel_h
#define _hmi5200_panel_h

/* LCDisplay definitions */
#define	LCD_MEMSIZE 0x8000
#define LCD_TEXTBASE 0x0000
#define LCD_LINELENGTH 30
#define	LCD_SCREENLENGTH 16
#define	LCD_GFXBASE 0x0200
#define	LCD_CGENBASE 0x7800

/* struct describing display organisation */
typedef struct lcd_organisation
{
	u16		textbase;
	u16		gfxbase;
	u16		cgenbase;	/* MUST be multiple of 0x800 ! */
	u16		width;		/* width in characters */
	u16		height;		/* height in characters */
} LCD_ORGANISATION;

/* struct describing a text marker */
typedef struct lcd_textmarker
{
	u8		left;
	u8		top;
	u8		right;
	u8		bottom;
	u8		on;
	u8		solid;
} LCD_TEXTMARKER;

/* struct describing a point */
typedef struct lcd_point
{
	u8		x;
	u8		y;
	u8		on;
} LCD_POINT;

/* struct describing encoder data */
typedef struct encoder
{
	int		value;
	int		lolim;
	int		hilim;
	int		state;
} ENCODER;

/* Ioctl definitions */
#define PANEL_MAGIC		'P'

/* LCD */
#define PANEL_SET_ORG		_IOW (PANEL_MAGIC, 0, LCD_ORGANISATION *)
#define PANEL_GET_ORG		_IOR (PANEL_MAGIC, 1, LCD_ORGANISATION *)
#define PANEL_FILL_TXT		_IOW (PANEL_MAGIC, 2, int)
#define PANEL_FILL_GFX		_IOW (PANEL_MAGIC, 3, int)
#define PANEL_MARK_TXT		_IOW (PANEL_MAGIC, 4, LCD_TEXTMARKER *)
#define	PANEL_PLOT			_IOW (PANEL_MAGIC, 5, LCD_POINT *)

/* Encoder */
#define	PANEL_GET_ENCODER	_IOR (PANEL_MAGIC, 100, ENCODER *)
#define	PANEL_SET_ENCODER	_IOW (PANEL_MAGIC, 101, ENCODER *)

/* ChipCard */
#define	PANEL_GET_CARD		_IOR (PANEL_MAGIC, 200, int *)
#define	PANEL_SET_CARD		_IOW (PANEL_MAGIC, 201, int *)

#endif
