/*
 *  linux/include/linux/mcc200spi.h
 *
 * 2006 (c) Wolfgang Denk, DENX Software Engineering, <wd@denx.de>
 *
 * This file is licensed under the term of  the GNU General Public License
 * version 2. The program licensed "as is" without any warranty of any
 * kind, whether express or implied.
 */
#ifndef MCC200SPI_H
#define MCC200SPI_H

#include <linux/spi.h>
#include <asm/ioctl.h>

#define MCC200SPI_MAJOR	188

#define SPIBUS(id)		(((id) & 0xf0) >> 4)
#define SPIDEV(id)		((id) & 0x0f)
#define SPIMKID(bus, dev)	(((bus) << 4) | (dev))

struct spi_setclock {
	int adap;
	int speed;
};

struct spi_rd {
	char id;		/* SPI device ID */
	struct timespec ts;	/* Linux timestamp */
	int nbytes;		/* Number of bytes available to read */
	char data[];		/* data, variable len */
};

/** IOCTL codes dor mcc200spi-dev.c */
#define MCC200_SPI_MAGIC	0xDE /* Seems to be unused */

/* Set bus speed */
#define SPI_SET_CLOCK	_IOW(MCC200_SPI_MAGIC, 0x80, struct spi_setclock)
/* Set device group */
#define SPI_SET_GROUP	_IOW(MCC200_SPI_MAGIC, 0x81, NULL)
/* Set buffer size */
#define SPI_SET_BUF 	_IOW(MCC200_SPI_MAGIC, 0x82, int)
/* Set polling period */
#define SPI_SET_PERIOD 	_IOW(MCC200_SPI_MAGIC, 0x83, int)

#endif /* MCC200SPI_H */
