/***********************************************************************
 *
 * (C) Copyright 2006
 * DENX Software Engineering
 * Heiko Schocher, hs@denx.de
 * All rights reserved.
 *
 ***********************************************************************/

#ifndef __PLD_DRV_H
#define __PLD_DRV_H 

#ifdef __KERNEL__
#include <linux/ioctl.h>
#else
#include <stdint.h>
#endif

#define CFG_PLD_LP_CS	3
#define CFG_LV541_LP_CS	4
#define	CFG_PLD_PADDR	0xe4000000
#define	CFG_LV541_PADDR	0xe4020000
#define	CFG_MINOR_LV541	0x10

/*
 * Ioctl definitions
 */
#define PLD_MAGIC		'P'

#define PLD_SET_F_VERS		_IOW (PLD_MAGIC, 0, unsigned int *)
#define PLD_GET_F_VERS		_IOR (PLD_MAGIC, 1, unsigned int *)

#define PLD_SET_L_VERS		_IOW (PLD_MAGIC, 2, unsigned int *)
#define PLD_GET_L_VERS		_IOR (PLD_MAGIC, 3, unsigned int *)

#define PLD_SET_DIP		_IOW (PLD_MAGIC, 4, unsigned int *)
#define PLD_GET_DIP		_IOR (PLD_MAGIC, 5, unsigned int *)

#define PLD_SET_ID		_IOW (PLD_MAGIC, 6, unsigned int *)
#define PLD_GET_ID		_IOR (PLD_MAGIC, 7, unsigned int *)

#define PLD_SET_SYSTEM		_IOW (PLD_MAGIC, 8, unsigned int *)
#define PLD_GET_SYSTEM		_IOR (PLD_MAGIC, 9, unsigned int *)

#define PLD_SET_LED1		_IOW (PLD_MAGIC, 10, unsigned int *)
#define PLD_GET_LED1		_IOR (PLD_MAGIC, 11, unsigned int *)

#define PLD_SET_LED2		_IOW (PLD_MAGIC, 12, unsigned int *)
#define PLD_GET_LED2		_IOR (PLD_MAGIC, 13, unsigned int *)

#define PLD_SET_LV541		_IOW (PLD_MAGIC, 14, unsigned int *)
#define PLD_GET_LV541		_IOR (PLD_MAGIC, 15, unsigned int *)

#endif /* __PLD_DRV_H */
