#ifndef _TQM5200_DIGIO_H
#define _TQM5200_DIGIO_H

/*
 * SM501 register definitions
 */
#define SM501_GPIO_CONTROL	0x000008
#define SM501_POWER_MODE0	0x000040
#define SM501_POWER_MODE1	0x000048
#define SM501_PWM_BASE		0x010020
#define SM501_PWM0		(SM501_PWM_BASE + 0x0)
#define SM501_PWM1		(SM501_PWM_BASE + 0x4)
#define SM501_PWM2		(SM501_PWM_BASE + 0x8)
#define SM501_ENDIAN_CTRL	0x00005C

#define PWM_REG_DEFAULT	0x5B95B970	/* 256 Hz, 50% duty cycle */
#define PWM_CYCLE_CNT	2930		/* lowest PWM frequency is 1 Hz */
#define PWM0_DUTY_CYCLE_DEFAULT	50	/* duty cycle default for channel 0 */

/*
 * stuff for ioctls
 *
 * start at 200 because other drivers use 'd' as part of their ioctl's
 */
#define TQM_DIGIO_IOCTL_MGC	'd'
#define DIGIO_CMD_PWM_START	_IOW(TQM_DIGIO_IOCTL_MGC, 200, unsigned int)
#define DIGIO_CMD_PWM_STOP	_IOW(TQM_DIGIO_IOCTL_MGC, 201, unsigned int)
#define DIGIO_CMD_SET_DUTY_CYCLE _IOW(TQM_DIGIO_IOCTL_MGC, 202, struct pwm_setdc*)
#define DIGIO_CMD_SET_PWM_FREQ	_IOW(TQM_DIGIO_IOCTL_MGC, 203, struct pwm_setdc*)
/* may be more later? */

/*
 * defines to make the association between channel number and output signal
 * more clearly. Please do not change, because the driver code does not use
 * this defines.
 */
#define GPIO29	0
#define GPIO30	1
#define GPIO31	2

/*
 * data structure for DIGIO_CMD_SET_DUTY_CYCLE ioclt
 */
struct pwm_setdc
{
	unsigned int channel;
	unsigned int duty_cycle;
};

#endif /* _TQM5200_DIGIO_H */
